function guildObject::messageAll(%this, %text)
{
	for(%i = 0; %i < %this.members; %i++)
	{
		if(isObject(%c = findClientByBL_ID(%this.member[%i])))
		{
			%c.chatMessage(%text);
		}
	}
}

function guildObject::removeMember(%this, %BLID)
{
	for(%i = 0; %i < %this.members; %i++)
	{
		if(%this.member[%i] == %BLID)
			%this.member[%i] = -1;
	}
	
	$guildMember[%BLID] = "";
	deleteVariables("$guildMember" @ %BL_ID);
	%this.realMemberCount--;
	%this.saveGuild();
}

function servercmdCreateGuild(%client, %name0, %name1, %name2, %name3)
{	
	if(isObject(%client.guild))
	{
		%client.chatMessage("You are already in a guild. Do /leaveGuild first.");
		return;
	}
	
	if(%client.guildCreationTime > $sim::time - 60)
	{
		%time = mCeil(60 - ($sim::Time - %client.guildCreationTime));
		
		%client.chatMessage("You need to wait" SPC %time SPC "more" SPC (%time == 1 ? "second" : "seconds") SPC "before you can create a guild.");
		return;
	}
	
	%guildName = stripMLControlChars(trim(%name0 SPC %name1 SPC %name2 SPC %name3));
	
	if(isFile("config/server/guilds/" @ %guildName @ ".dat"))
	{
		%client.chatMessage("A guild by this name already exists.");
	}
	
	if(strLen(%guildName) > 20 && !%client.isAdmin)
	{
		%client.chatMessage("Please make your guild name shorter.");
		return;
	}
	
	%index = $guildIndexTotal++;
	
	%guild = new ScriptObject(guildObject)
	{
		guildName = %guildName;
		guildMaster = %client.BL_ID;
		members = 1;
		realMemberCount = 1;
		member0 = %client.BL_ID;
		guildIndex = %index;
	};
	
	$guildIndex[%index] = %guild;
	
	missionCleanup.add(%guild);
	%client.guild = %guild;
	%client.guildCreationTime = $sim::time;
	$guildMember[%client.BL_ID] = %index;
	%guild.saveGuild();
	announce(%client.name SPC "has founded the" SPC %guildName SPC "guild.");
}

function servercmdDisbandGuild(%client)
{
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	if(%client.guild.guildMaster != %client.BL_ID)
	{
		%client.chatMessage("Only the guild leader can do this.");
		return;
	}
	
	announce("The" SPC %client.guild.guildName SPC "guild was disbanded.");
	$guildIndex[%client.guild.guildIndex] = "";
	deleteVariables("$guildIndex" @ %client.guild.guildIndex);
	fileDelete("config/server/guilds/" @ %client.guild.guildName @ ".dat");
	%client.guild.delete();
}

function servercmdInvite(%client, %name0, %name1, %name2, %name3)
{
	if(%client.lastGuildInviteAttempt > $sim::time + 4)
	{
		%client.lastGuildInviteAttempt = $sim::time;
		%client.chatMessage("Slow down there.");
		return;
	}
	
	%client.lastGuildInviteAttempt = $sim::time;
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	if(%client.guild.guildMaster != %client.BL_ID)
	{
		%client.chatMessage("Only the guild leader can do that.");
		return;
	}
	
	%name = trim(%name0 SPC %name1 SPC %name2 SPC %name3);
	
	if(%name $= "")
	{
		%client.chatMessage("You must specify a name.");
		return;
	}
	
	%target = findclientbyname(%name);
	
	if(!isObject(%target))
	{
		%client.chatMessage("Could not find anyone by that name.");
		return;
	}
	
	if(isObject(%target.guild))
	{
		%client.chatMessage("That person is already in another guild.");
		return;
	}
	
	if(%target.guildInviteTime > $sim::time - 20)
	{
		%client.chatMessage("That person is busy with another invite. Wait a minute.");
		return;
	}
	
	%client.chatMessage("Invite sent!");
	%target.guildInvite = %client.guild;
	%target.guildInviteTime = $sim::time;
	%target.chatMessage("You have been invited to join the" SPC %client.guild.guildName SPC "guild. Do /acceptInvite, or just ignore it.");
}

function servercmdAcceptInvite(%client)
{
	if(!isObject(%client.guildInvite))
	{
		%client.chatMessage("You don't have a pending invite.");
		return;
	}
	
	%client.guild = %client.guildInvite;
	%client.guildInvite = "";
	
	%client.guild.member[%client.guild.members] = %client.BL_ID;
	%client.guild.members++;
	%client.guild.realMemberCount++;
	$guildMember[%client.BL_ID] = %client.guild.guildIndex;
	%client.guild.saveGuild();
	
	%client.guild.messageAll("\c5" @ %client.name SPC "has joined the guild!");
}

function servercmdPromoteLeader(%client, %name0, %name1, %name2, %name3)
{
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	if(%client.guild.guildMaster != %client.BL_ID)
	{
		%client.chatMessage("Only the guild leader can do that.");
		return;
	}
	
	%name = trim(%name0 SPC %name1 SPC %name2 SPC %name3);
	
	if(%name $= "")
	{
		%client.chatMessage("You must specify a name.");
		return;
	}
	
	%target = findclientbyname(%name);
	
	if(%target.guild != %client.guild)
	{
		%client.chatMessage("That person isn't in your guild.");
		return;
	}
	
	%client.guild.guildMaster = %target.BL_ID;
	%client.guild.saveGuild();
	%client.guild.messageAll("\c5" @ %client.name SPC "has relinquished ownership of the guild to" SPC %target.name);
}

function servercmdDismiss(%client, %name0, %name1, %name2, %name3)
{
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	if(%client.guild.guildMaster != %client.BL_ID)
	{
		%client.chatMessage("Only the guild leader can do that.");
		return;
	}
	
	%name = trim(%name0 SPC %name1 SPC %name2 SPC %name3);
	
	if(%name $= "")
	{
		%client.chatMessage("You must specify a name.");
		return;
	}
	
	%target = findclientbyname(%name);
	
	if(!%target.guild == %client.guild)
	{
		%client.chatMessage("That player isn't in your guild.");
		return;
	}
	
	if(%client.guild.guildMaster == %target.BL_ID)
	{
		%client.chatMessage("You have to appoint a new leader to the guild first. Do /promoteLeader <name>, or disband your guild entirely with /disbandGuild");
		return;
	}
	
	%target.guild = "";
	%client.guild.removeMember(%target.BL_ID);
	%client.guild.saveGuild();
	%client.guild.messageAll("\c5" @ %target.name SPC "has been dismissed from the guild.");
}

function servercmdLeaveGuild(%client)
{
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	if(%client.guild.guildMaster == %client.BL_ID)
	{
		%client.chatMessage("You have to appoint a new leader to the guild first. Do /promoteLeader <name>, or disband your guild entirely with /disbandGuild");
		return;
	}
	
	%guild = %client.guild;
	
	if(%client.guild.realMemberCount == 1)
	{
		announce("The" SPC %guild.guildName SPC "guild was disbanded.");
		$guildIndex[%guild.guildIndex] = "";
		deleteVariables("$guildIndex" @ %guild.guildIndex);
		fileDelete("config/server/guilds/" @ %guild.guildName @ ".dat");
		%guild.delete();
		%client.guild = "";
		return;
	}
	
	
	%guild.messageAll("\c5" @ %client.name SPC "has left the guild.");
	%guild.removeMember(%client.BL_ID);
	%client.guild = "";
}

function servercmdListGuildMembers(%client)
{
	if(!isObject(%client.guild))
	{
		%client.chatMessage("You don't have a guild.");
		return;
	}
	
	%client.chatMessage("\c3Guild:" SPC %client.guild.guildName SPC "- Total members:" SPC %client.guild.realMemberCount);
	for(%i = 0; %i < %client.guild.members; %i++)
	{
		if(%client.guild.member[%i] > 0)
			%client.chatMessage("\c6" @ (findClientByBL_ID(%client.guild.member[%i]) ? "Name:" SPC findClientByBL_ID(%client.guild.member[%i]).name SPC "-" : "") SPC "BLID:" SPC %client.guild.member[%i]);
	}
}

function guildObject::saveGuild(%this)
{
	export("$guild*", "config/server/guilds/guildMembers.cs");
	%file = new FileObject(){};
	%file.openForWrite("config/server/guilds/" @ %this.guildName @ ".dat");
	
	%file.writeLine("INDEX" TAB %this.guildIndex);
	%file.writeLine("NAME" TAB %this.guildName);
	%file.writeLine("GM" TAB %this.guildMaster);
	%file.writeLine("MEMBERS" TAB %this.members);
	%file.writeLine("REALMEMBERS" TAB %this.realMemberCount);
	
	for(%i = 0; %i < %this.members; %i++)
	{
		if(%this.member[%i] > 0)
			%file.writeLine("MEMBER" TAB %i TAB %this.member[%i]);
	}
	
	%file.close();
	%file.delete();
}

function loadGuilds()
{
	exec("config/server/guilds/guildMembers.cs");
	%fileObject = new FileObject(){};
	for(%file = findFirstFile("config/server/guilds/*.dat"); isFile(%file); %file = findNextFile("config/server/guilds/*.dat"))
	{
		%fileObject.openForRead(%file);
		
		%guild = new ScriptObject(guildObject)
		{
			guildName = 0;
			guildMaster = 0;
			members = 0;
			realMemberCount = 0;
			guildIndex = 0;
		};
				
		while(!%fileObject.isEOF())
		{
			%line = %fileObject.readLine();
			%command = getField(%line, 0);
			%value = getField(%line, 1);
			
			switch$(%command)
			{
				case "INDEX":
					%guild.guildIndex = %value;
					$guildIndex[%value] = %guild;
				
				case "NAME":
					%guild.guildName = %value;
					
				case "GM":
					%guild.guildMaster = %value;
					
				case "MEMBERS":
					%guild.members = %value;
					
				case "REALMEMBERS":
					%guild.realMemberCount = %value;
					
				case "MEMBER":
					%guild.member[%value] = getField(%line, 2);
			}
		}
		
		echo("Loaded the" SPC %guild.guildName SPC "guild.");
		%fileObject.close();
	}
	
	%fileObject.delete();
}

if(!$_guildsLoaded)
	loadGuilds();
$_guildsLoaded = true;


package guildChatPackage
{
	function servercmdTeamMessageSent(%client, %msg)
	{
		if(isObject(%client.guild))
		{
			%msg = stripMLControlChars(getSubStr(%msg, 0, $Pref::Server::MaxChatLen));
			
			if(%msg $= %client.lastGuildMessage && !%client.isAdmin)
			{
				%client.chatMessage("\c5Do not repeat yourself.");
				return;
			}
			
			%client.guild.messageAll("\c5(" @ %client.guild.guildName @ ")\c6" SPC %client.name @ (%client.guild.guildMaster == %client.BL_ID ? " \c5(Leader)\c6" : "") @ ":" SPC %msg);
			echo("[Guild chat](" @ %client.guild.guildName @ ")" SPC %client.name @ ":" SPC %msg);
			servercmdstopTalking(%client);
			return;
		}
		
		return parent::servercmdTeamMessageSent(%client, %msg);
	}
	
	function gameConnection::autoAdminCheck(%this)
	{
		if($guildMember[%this.BL_ID] > 0)
			%this.guild = $guildIndex[$guildMember[%this.BL_ID]];
		
		return parent::autoAdminCheck(%this);
	}
};
activatePackage(guildChatPackage);